<?php
namespace PriorityOneMarketingGroup;

class Clubs {
    /**
     * @param object $conn
     * @param string $action
     * @param int $key
     * @param array $params
     */
    public function __construct($conn = null, $method = null, $action = null, $key = null, $values = array(), $params = array())
    {
        $this->mysql_connection = $conn;
        $this->key = $key;
        $this->params = $params;
        $this->method = $method;
        $this->values = $values;

        switch ($action) {
            case 'all':
                $this->results = self::getAllClubs();
                break;

            case 'list':
                $this->results = self::getClubList();
                break;

            case 'club':
                if($this->method == 'GET')
                    $this->results = self::getClub();

                if($this->method == 'POST')
                    $this->results = self::createClub();

                if($this->method == 'PUT')
                    $this->results = self::updateClub();

                if($this->method == 'DELETE')
                    $this->results = self::deleteClub();
                break;

            case 'search':
                $this->results = self::searchClubs();
                break;

            case 'total':
                $this->results = self::getTotalClubs();
                break;

            case 'rearrange':
                $this->results = self::rearrangeClubProject();
                break;
        }
    }

    public function getResults(){
        $return = self::createJSON($this->results);

        return $return;
    }

    private function getAllClubs(){
        $return = $this->mysql_connection->select("SELECT * FROM clubs");

        return $return;
    }

    private function getTotalClubs(){
        $total = $this->mysql_connection->select("SELECT COUNT(*) AS total FROM clubs");

        $return[0]['total'] = $total[0]->total;

        return $return;
    }

    private function getClubList(){
        $sql .= "SELECT id, name, contact, city, state FROM clubs";

        if(isset($this->params['sortBy']) && isset($this->params['dir'])){
            $sql .= " ORDER BY ".$this->params['sortBy']." ".$this->params['dir'];
        }else{
            $sql .= " ORDER BY id DESC";
        }

        if(isset($this->params['offset']) && isset($this->params['total'])){
            $start = $this->params['offset'];
            $total = ($start + $this->params['total']);
        }else{
            $start = 0;
            $total = 100;
        }
        
        $sql .= " LIMIT $start, $total";

        $return = $this->mysql_connection->select($sql);

        for ($i=0; $i < count($return); $i++) {
            $sql = "SELECT p.title FROM clubProjects c LEFT JOIN projects p ON p.id = c.projectID WHERE c.clubID ='".$return[$i]->id."' ORDER BY c.id DESC LIMIT 1";

            $project = $this->mysql_connection->select($sql);
            $return[$i]->project = $project[0]->title;
        }

        if(isset($this->params['sortBy']) && $this->params['sortBy'] == 'project'){
            usort($return, function($a, $b) {
                return $a->project <=> $b->project;
            });
        }

        return $return;
    }

     private function getClub(){
        $return = $this->mysql_connection->select("SELECT * FROM clubs WHERE id = $this->key");

        $projects = $this->mysql_connection->select("SELECT p.id FROM clubProjects cp LEFT JOIN projects p ON p.id = cp.projectID WHERE clubID = $this->key ORDER BY id");

        $temp = array();

        for ($i=0; $i < count($projects); $i++) {
            array_push($temp, $projects[$i]->id);
        }

        $return[0]->projects = $temp;

        return $return;
    }

    private function deleteClub(){
        $this->mysql_connection->delete("DELETE FROM clubs WHERE id=$this->key");
        $this->mysql_connection->delete("DELETE FROM clubProjects WHERE clubID=$this->key");

        $return[0]['success'] = TRUE;

        return $return;
    }

    private function updateClub(){
        extract($this->values);

        $name = $this->mysql_connection->real_escape_string($name);
        $contact = $this->mysql_connection->real_escape_string($contact);
        $job = $this->mysql_connection->real_escape_string($job);
        $address1 = $this->mysql_connection->real_escape_string($address1);
        $address2 = $this->mysql_connection->real_escape_string($address2);
        $city = $this->mysql_connection->real_escape_string($city);
        $notes = $this->mysql_connection->real_escape_string($notes);

        $this->mysql_connection->update("UPDATE clubs SET name='$name', contact='$contact', job='$job', address1='$address1', address2='$address2', phone1='$phone1', phone2='$phone2', email='$email', city='$city', state='$state', zip='$zip', notes='$notes', fax='$fax', faxed='$faxed', confirmed='$confirmed', signed='$signed', paperwork='$paperwork' WHERE id=$this->key");

        $this->mysql_connection->delete("DELETE FROM clubProjects WHERE clubID=$this->key");

        for ($i=0; $i < count($projects); $i++) {
            $projectID = $projects[$i];

            $this->mysql_connection->insert("INSERT INTO clubProjects (clubID, projectID) VALUES ('$this->key', '$projectID')");
        }

        $return[0]['success'] = TRUE;
        $return[0]['id'] = $this->key;

        return $return;
    }

    private function createClub(){
        extract($this->values);

        $name = $this->mysql_connection->real_escape_string($name);
        $contact = $this->mysql_connection->real_escape_string($contact);

        $this->mysql_connection->insert("INSERT INTO clubs (name, contact, job, address1, address2, phone1, phone2, email, city, state, zip, notes, fax, faxed, confirmed, signed, paperwork) VALUES ('$name', '$contact', '$job', '$address1', '$address2', '$phone1', '$phone2', '$email', '$city', '$state', '$zip', '$notes', '$fax', '$faxed', '$confirmed', '$signed', '$paperwork')");

        $id = $this->mysql_connection->getLastID();

        for ($i=0; $i < count($projects); $i++) {
            $projectID = $projects[$i];

            $this->mysql_connection->insert("INSERT INTO clubProjects (clubID, projectID) VALUES ('$id', '$projectID')");
        }

        $return[0]['success'] = TRUE;
        $return[0]['id'] = $id;

        return $return;
    }

    private function searchClubs(){
        if(isset($this->params['keyphrase'])){
            $searchTerm = urldecode($this->params['keyphrase']);
        }else{
            $searchTerm = '';
        }

        $i = 0;

        $names = $this->mysql_connection->select("SELECT id, name, contact, city, state FROM clubs WHERE name LIKE '%$searchTerm%'");

        if(count($names) > 0){
            for ($j=0; $j < count($names); $j++) {
                $sql = 'SELECT p.title FROM clubProjects c LEFT JOIN projects p ON p.id = c.projectID WHERE c.clubID ='.$names[$j]->id." ORDER BY c.id DESC LIMIT 1";

                $project = $this->mysql_connection->select($sql);

                if(count($project) > 0){
                    $names[$j]->project = $project[0]->title;
                }
            }
        }

        $return[$i]["name"] = "Name";
        $return[$i]["entries"] = $names;

        $i++;

        $contacts = $this->mysql_connection->select("SELECT id, name, contact, city, state FROM clubs WHERE contact LIKE '%$searchTerm%'");

        if(count($contacts) > 0){
            for ($j=0; $j < count($contacts); $j++) {
                $sql = 'SELECT p.title FROM clubProjects c LEFT JOIN projects p ON p.id = c.projectID WHERE c.clubID ='.$contacts[$j]->id." ORDER BY c.id DESC LIMIT 1";

                $project = $this->mysql_connection->select($sql);

                if(count($project) > 0){
                    $contacts[$j]->project = $project[0]->title;
                }
            }
        }

        $return[$i]["name"] = "Contact";
        $return[$i]["entries"] = $contacts;

        $i++;

        $cities = $this->mysql_connection->select("SELECT id, name, contact, city, state FROM clubs WHERE city LIKE '%$searchTerm%'");

        if(count($cities) > 0){
            for ($j=0; $j < count($cities); $j++) {
                $sql = 'SELECT p.title FROM clubProjects c LEFT JOIN projects p ON p.id = c.projectID WHERE c.clubID ='.$cities[$j]->id." ORDER BY c.id DESC LIMIT 1";

                $project = $this->mysql_connection->select($sql);

                if(count($project) > 0){
                    $cities[$j]->project = $project[0]->title;
                }
            }
        }

        $return[$i]["name"] = "City";
        $return[$i]["entries"] = $cities;

        $i++;

        $states = $this->mysql_connection->select("SELECT id, name, contact, city, state FROM clubs WHERE state LIKE '%$searchTerm%'");

        if(count($states) > 0){
            for ($j=0; $j < count($states); $j++) {
                $sql = 'SELECT p.title FROM clubProjects c LEFT JOIN projects p ON p.id = c.projectID WHERE c.clubID ='.$states[$j]->id." ORDER BY c.id DESC LIMIT 1";

                $project = $this->mysql_connection->select($sql);

                if(count($project) > 0){
                    $states[$j]->project = $project[0]->title;
                }
            }
        }

        $return[$i]["name"] = "State";
        $return[$i]["entries"] = $states;

        $i++;

        $emails = $this->mysql_connection->select("SELECT id, name, contact, city, state FROM clubs WHERE email LIKE '%$searchTerm%'");

        if(count($emails) > 0){
            for ($j=0; $j < count($emails); $j++) {
                $sql = 'SELECT p.title FROM clubProjects c LEFT JOIN projects p ON p.id = c.projectID WHERE c.clubID ='.$emails[$j]->id." ORDER BY c.id DESC LIMIT 1";

                $project = $this->mysql_connection->select($sql);

                if(count($project) > 0){
                    $emails[$j]->project = $project[0]->title;
                }
            }
        }

        $return[$i]["name"] = "Email";
        $return[$i]["entries"] = $emails;

        $i++;

        $phones = $this->mysql_connection->select("SELECT id, name, contact, city, state FROM clubs WHERE phone1 LIKE '%$searchTerm%'");

        if(count($phones) > 0){
            for ($j=0; $j < count($phones); $j++) {
                $sql = 'SELECT p.title FROM clubProjects c LEFT JOIN projects p ON p.id = c.projectID WHERE c.clubID ='.$phones[$j]->id." ORDER BY c.id DESC LIMIT 1";

                $project = $this->mysql_connection->select($sql);

                if(count($project) > 0){
                    $phones[$k]->project = $project[0]->title;
                }
            }
        }

        $return[$i]["name"] = "Phone";
        $return[$i]["entries"] = $phones;

        $i++;

        $clubIDs = $this->mysql_connection->select("SELECT cp.clubID FROM clubProjects cp LEFT JOIN projects p ON p.id = cp.projectID WHERE p.title LIKE '%$searchTerm%'");

        $inStatement = '';

        for ($j=0; $j < count($clubIDs); $j++) { 
            if($j != 0){
                $inStatement .= ",";
            } 
            $inStatement .= $clubIDs[$j]->clubID;
        }

        if($inStatement != ''){
            $projects = $this->mysql_connection->select("SELECT id, name, contact, city, state FROM clubs WHERE id IN ($inStatement)");

            if(count($projects) > 0){
                for ($k=0; $k < count($projects); $k++) {
                    $sql = 'SELECT p.title FROM clubProjects c LEFT JOIN projects p ON p.id = c.projectID WHERE c.clubID ='.$projects[$k]->id." ORDER BY c.id DESC LIMIT 1";

                    $project = $this->mysql_connection->select($sql);

                    if(count($project) > 0){
                        $projects[$k]->project = $project[0]->title;
                    }
                }
            }
        }else{
            $projects = [];
        }

        $return[$i]["name"] = "Project";
        $return[$i]["entries"] = $projects;

        $j++;

        return $return;
    }

    private function rearrangeClubProject(){
        $clubs = $this->mysql_connection->select("SELECT p.id AS project_id, c.id AS club_id FROM clubs c INNER JOIN projects p ON p.title = c.project OR p.title = c.project2 OR p.title = c.project3 OR p.title = c.project4 OR p.title = c.project5");

        for ($i=0; $i < count($clubs); $i++) {
            $clubID = $clubs[$i]->club_id;
            $projectID = $clubs[$i]->project_id;

            $this->mysql_connection->insert("INSERT INTO clubProjects (clubID, projectID) VALUES ('$clubID', '$projectID')");
        }

        $return['success'] = TRUE;

        return $return;
    }

    private function createJSON($results){
        for ($i=0;$i<count($results);$i++) {
            if(count($results) > 1 && $i == 0) $return .= '[';
            $return .= ($i>0?',':'').json_encode($results[$i]);
            if(count($results) > 1 && $i == (count($results)-1)) $return .= ']';
        }
        ;
        return $return;
    }
}

?>