<?php
namespace PriorityOneMarketingGroup;

class Users {
    /**
     * @param object $conn
     * @param string $action
     * @param int $key
     * @param array $params
     */
    public function __construct($conn = null, $method = "", $action = null, $key = null, $values= array(), $params = array())
    {
    	$this->mysql_connection = $conn;
        $this->key = $key;
        $this->params = $params;
        $this->method = $method;
        $this->values = $values;

    	switch ($action) {
    		case 'all':
    			$this->results = self::getAllUsers();
    			break;

    		case 'allActiveUsers':
    			$this->results = self::getAllActiveUsers();
    			break;

    		case 'user':
                if($this->method == 'GET')
                    $this->results = self::getSingleUser();

                if($this->method == 'POST')
                    $this->results = self::createUser();

                if($this->method == 'PUT')
                    $this->results = self::updateUser();

                if($this->method == 'DELETE')
                    $this->results = self::deleteUser();
    			
    			break;

    		case 'checkPassword':
    			$this->results = self::checkPassword();
    			break;

    		case 'getUserLevel':
    			$this->results = self::checkLevel();
    	}
    }

    public function getResults(){
    	$return = self::createJSON($this->results);

    	return $return;
    }

    private function getAllUsers(){
    	$return = $this->mysql_connection->select("SELECT * FROM users");

    	return $return;
    }

    private function getAllActiveUsers(){
    	$return = $this->mysql_connection->select("SELECT id, first, last, user, email FROM users WHERE hidden = 0 AND active = 1");

        return $return;
    }

    private function getSingleUser(){
    	$return = $this->mysql_connection->select("SELECT id, first, last, user, email, active, level FROM users WHERE id = $this->key");

    	return $return;
    }

    private function deleteUser(){
        $this->mysql_connection->delete("DELETE FROM users WHERE id=$this->key");

        $return[0]['success'] = TRUE;

        return $return;
    }

    private function updateUser(){
        extract($this->values);

        $this->mysql_connection->update("UPDATE users SET first='$first', last='$last', user='$user', ".(($password != '') ? "password='".md5($password)."', " : "" )."email='$email', active='$active', level='$level' WHERE id=$this->key");

        $return[0]['success'] = TRUE;
        $return[0]['id'] = $this->key;

        return $return;
    }

    private function createUser(){
        extract($this->values);

        $this->mysql_connection->insert("INSERT INTO users (first, last, user, password, email, active, level, hidden) VALUES ('$first', '$last', '$user', '$password', '$email', '$active', '$level', 0)");

        $id = $this->mysql_connection->getLastID();

        $return[0]['success'] = TRUE;
        $return[0]['id'] = $id;

        return $return;
    }

    private function checkPassword(){
    	$username = $this->params['username'];

    	$user_password = $this->mysql_connection->select("SELECT id, level, password FROM users WHERE user = '$username'");

    	$pass = ($user_password[0]->password == md5($this->params['password'])) ? TRUE : FALSE;

        $return[0]['success'] = TRUE;
        $return[0]['pass'] = $pass;
        $return[0]['id'] = $user_password[0]->id;
        $return[0]['level'] = $user_password[0]->level;

    	return $return;
    }

    private function getUserLevel(){
    	$return = $this->mysql_connection->select("SELECT level FROM users WHERE id = $key");

    	return $return;
    }

    private function createJSON($results){
		for ($i=0;$i<count($results);$i++) {
			if(count($results) > 1 && $i == 0) $return .= '[';
			$return .= ($i>0?',':'').json_encode($results[$i]);
			if(count($results) > 1 && $i == (count($results)-1)) $return .= ']';
		}

		return $return;
    }
}

?> 